// Type definitions for @ckeditor/ckeditor5-image 27.1
// Project: https://ckeditor.com/docs/ckeditor5/latest/api/image.html
// Definitions by: Federico Panico <https://github.com/fedemp>
// Definitions: https://github.com/DefinitelyTyped/DefinitelyTyped
// Minimum TypeScript Version: 4.2
import AutoImage from './src/autoimage';
import Image from './src/image';
import ImageEditing from './src/image/imageediting';
import ImageCaption from './src/imagecaption';
import ImageCaptionEditing from './src/imagecaption/imagecaptionediting';
import ImageInsert from './src/imageinsert';
import ImageInsertUI from './src/imageinsert/imageinsertui';
import ImageResize from './src/imageresize';
import ImageResizeButtons from './src/imageresize/imageresizebuttons';
import ImageResizeEditing from './src/imageresize/imageresizeediting';
import ImageResizeHandles from './src/imageresize/imageresizehandles';
import ImageStyle from './src/imagestyle';
import ImageStyleEditing from './src/imagestyle/imagestyleediting';
import ImageStyleUI from './src/imagestyle/imagestyleui';
import ImageTextAlternative from './src/imagetextalternative';
import ImageTextAlternativeEditing from './src/imagetextalternative/imagetextalternativeediting';
import ImageTextAlternativeUI from './src/imagetextalternative/imagetextalternativeui';
import ImageToolbar from './src/imagetoolbar';
import ImageUpload from './src/imageupload';
import ImageUploadEditing from './src/imageupload/imageuploadediting';
import ImageUploadProgress from './src/imageupload/imageuploadprogress';
import ImageUploadUI from './src/imageupload/imageuploadui';

declare const _default: {
    AutoImage: typeof AutoImage;
    Image: typeof Image;
    ImageEditing: typeof ImageEditing;
    ImageCaption: typeof ImageCaption;
    ImageCaptionEditing: typeof ImageCaptionEditing;
    ImageInsert: typeof ImageInsert;
    ImageInsertUI: typeof ImageInsertUI;
    ImageResize: typeof ImageResize;
    ImageResizeButtons: typeof ImageResizeButtons;
    ImageResizeEditing: typeof ImageResizeEditing;
    ImageResizeHandles: typeof ImageResizeHandles;
    ImageStyle: typeof ImageStyle;
    ImageStyleEditing: typeof ImageStyleEditing;
    ImageStyleUI: typeof ImageStyleUI;
    ImageTextAlternative: typeof ImageTextAlternative;
    ImageTextAlternativeEditing: typeof ImageTextAlternativeEditing;
    ImageTextAlternativeUI: typeof ImageTextAlternativeUI;
    ImageToolbar: typeof ImageToolbar;
    ImageUpload: typeof ImageUpload;
    ImageUploadEditing: typeof ImageUploadEditing;
    ImageUploadProgress: typeof ImageUploadProgress;
    ImageUploadUI: typeof ImageUploadUI;
};

export default _default;
